//--- Buck Roger's Ray Gun

//  Original file by Mike Miller
//
//  Modified for POV-Ray version 3.x by
//  Colin Fleming, cj_fleming@btinternet.com
//

#declare Gun =
object {
	union { 
		union {
			object { Disk_Y scale <8, 27, 6> translate <0, -2, 0> }
			object { Disk_X scale <42.5, 6.5, 12.1> translate <-7.7, 27.9, 0> }
			object { Disk_X scale <1, 12, 12> translate <-75, 33.4, 0> }
			object { Disk_X scale <1, 12, 12> translate <-71, 33.4, 0> }
			object { Disk_X scale <1, 12, 12> translate <-67, 33.4, 0> }
			texture { RayGunGreen }
			bounded_by { object { UnitBox scale <57, 40, 13> translate <-20.5, 11.9, 0> } }
		}
		union {
			cylinder { <1, 0, 0>, <-1, 0, 0>, 1 scale <41, 8, 8> translate <-39, 33.4, 0> }
			object { Sphere scale <8, 8, 8> translate <-80, 33.4, 0> }
			object { Sphere scale <8, 8, 8> translate <2, 33.4, 0> }
			object { Sphere scale <8, 8, 8> translate <10, 33.4, 0> }
			object { Sphere scale <8, 8, 8> translate <18, 33.4, 0> }
			object { Sphere scale <8, 8, 8> translate <26, 33.4, 0> }
			object { Disk_X scale <20, 7.5, 4> translate <6, 41.9, 0> }
			texture { Gold3 }
			bounded_by { object { UnitBox scale <62, 16, 10> translate <-28.1, 34.9, 0> } }
		}
        bounded_by { object { UnitBox scale <68, 42, 13> translate <-26.9, 14.4, 0> } }
	}
} 


//--- Gun with Ray
#declare RayGun =
union {
	object { Gun }
	//-- Laser photon
	//object { Sphere  scale <16, 10, 10> translate <-100, 33.4, 0> material { LaserDust translate <-88, 0, 0> } }

	//sorry, cheated!
	object { Sphere scale <16, 10, 10> translate <-100 33.4, 0> pigment { Orange filter 0.25 } interior { ior 2 } }

	object { Disk_X scale <7022, 7, 7> translate <-7100, 33.4, 0> texture { Laser } }
}
